--[[
	GemCensus: A gem popularity addon.
	Copyright (c) 2010 Cyprias <Cyprias@gmail.com>
	All Rights Reserved.
	Only Curse.com, WoWInterface.com & WoWace.com have permission to redistribute this software. 
	GemCensus shall not be included in a UI pack / compilation without permission. 
]]

local folder, core = ...
local Debug = core.Debug

local UnitName = UnitName
local iLink = core.iLink
local NUM_BAG_FRAMES = NUM_BAG_FRAMES
local GetContainerNumSlots = GetContainerNumSlots
local GetContainerItemID = GetContainerItemID
local GetItemInfo = GetItemInfo
local GetContainerItemInfo = GetContainerItemInfo
local pairs = pairs


function core:BAG_UPDATE(event, bagID)
	
	local numSlots = GetContainerNumSlots(bagID)
	local name = UnitName("player")
	
	local itemID
	for s=1, numSlots do 
		itemID = GetContainerItemID(bagID, s)
		if itemID and core:IsGem(itemID) then
--~ 			Debug(event, bagID, s, iLink[itemID], core:IsGem(itemID))
			
--~ 			self.db.factionrealm.knownCuts[me] = cuts
			self.db.factionrealm.myInventory[name] = self.db.factionrealm.myInventory[name] or {}
			self.db.factionrealm.myInventory[name][bagID] = self.db.factionrealm.myInventory[name][bagID] or {}
			
			local _, count = GetContainerItemInfo(bagID, s)

			self.db.factionrealm.myInventory[name][bagID][s] = {id=itemID, count=count}
			
			
		else
			if self.db.factionrealm.myInventory[name] and self.db.factionrealm.myInventory[name][bagID] then
				self.db.factionrealm.myInventory[name][bagID][s] = nil
			end
		end
	end
end

function core:SaveInventory()
	local name = UnitName("player")
	self.db.factionrealm.myInventory[name] = nil
	
	local numSlots
	for bagID=1, NUM_BAG_FRAMES do 
		 self:BAG_UPDATE("BAG_UPDATE", bagID)
	end
end

function core:SayMyGems()--		/run _GC:SayMyGems()
	local name = UnitName("player")
	
	if self.db.factionrealm.myInventory[name] then
		for bagID, slots in pairs(self.db.factionrealm.myInventory[name]) do 
			for slot, slotInfo in pairs(slots) do 
				
				Debug("SayMyGems", bagID, slot, iLink[slotInfo.id], slotInfo.count)
			
			end
			
			
		end
	
	end
end

function core:GetMyGems()--		/run _GC:GetMyGems()
	local myGems = {}

	
	
--~ 	if self.db.factionrealm.myInventory[name] then
	
		for name, inv in pairs(self.db.factionrealm.myInventory) do 
	
			for bagID, slots in pairs(inv) do 
				for slot, slotInfo in pairs(slots) do 
					
	--~ 				Debug("SayMyGems", bagID, slot, iLink[slotInfo.id], slotInfo.count)
					
					myGems[name] = myGems[name] or {}
					
					myGems[name][slotInfo.id] = (myGems[name][slotInfo.id] or 0) + 1
					
				end
				
				
			end
		end
--~ 	end
	
--~ 	for name, inv in pairs(myGems) do 
--~ 		for gemID, count in pairs(inv) do 
--~ 			Debug("SayMyGems", name, iLink[gemID], count)
--~ 		end
--~ 	end
	
	return myGems
end

function core:BuildInvOptions()
	local name = UnitName("player")
	
	
end

function core:IsGem(itemID)
	local itemLink = iLink[itemID]
	local _, _, _, _, _, itemType = GetItemInfo(itemLink)
	return itemType == "Gem"
end